import ssconst
import struct

#---------------
# Start other crap
#---------------

def readUint32BE(in_file, times=1):
    return struct.unpack('>' + str(times) + 'I', in_file.read(4 * times))

def writeUint32BE(out_file, values):
    if type(values) == list or type(values) == tuple:
        return out_file.write(struct.pack('>' + str(len(values)) + 'I', *values))
    return out_file.write(struct.pack('>I', values))

def generate_sound_text(offset, aux_data_size):
    """Accepts an offset and the size of any aux data (such as size of
    the lip synch tags + header size). Returns a string, containing the embedded
    script code to trigger a sound."""
    offsethex = hex(offset).rstrip('L').upper()
    offsethex = offsethex[2:].zfill(8)

    auxsizehex = hex(aux_data_size).rstrip('L').upper()
    auxsizehex = auxsizehex[2:].zfill(8)

    sound_text = ssconst.strSoundTrigger + \
           "\\x" + offsethex[6:8] + "\\x" + offsethex[4:6] + \
           ssconst.strSoundTrigger + \
           "\\x" + offsethex[2:4] + "\\x" + offsethex[0:2] + \
           ssconst.strSoundTrigger + \
           "\\x" + auxsizehex[6:8] + "\\x" + auxsizehex[4:6] + \
           ssconst.strSoundTrigger + \
           "\\x" + auxsizehex[2:4] + "\\x" + auxsizehex[0:2]
    
    return sound_text

def indent_elementtree(elem, level=0):
    """ This function taken from http://effbot.org/zone/element-lib.htm#prettyprint.
    By Fredrik Lundh & Paul Du Bois."""
    i = "\n" + (level * "  ")
    if len(elem):
        if not elem.text or not elem.text.strip():
            elem.text = i + "  "
        if not elem.tail or not elem.tail.strip():
            elem.tail = i
        for child in elem:
            indent_elementtree(child, level+1)
        if not child.tail or not child.tail.strip():
            child.tail = i
        if not elem.tail or not elem.tail.strip():
            elem.tail = i
    else:
        if level and (not elem.tail or not elem.tail.strip()):
            elem.tail = i

def updateObservers(wfunc):
    def inner_func(self, *args, **kwds):
        wfunc(self, *args, **kwds)
        self.updateObservers()
    return inner_func