import ssglob
# -*- coding: iso-8859-1 -*-
# Pretty much duplicate of NewSpeechMapDialog

import wx

class ExportToGameResourcesDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.szrText_staticbox = wx.StaticBox(self, -1, "Text file")
        self.szrResource_staticbox = wx.StaticBox(self, -1, "Sound Resource")
        self.szrHelpText_staticbox = wx.StaticBox(self, -1, "Export to Game Resources")
        self.lblHelpText = wx.StaticText(self, -1, "Please specify a path and filename for the dialogue text (which will be modified to trigger the appropriate sounds), and the sound resource file. You must manually insert the new text file into the game using ScummTr.")
        self.txtCtrlTextFile = wx.TextCtrl(self, -1, "")
        self.btnBrowseText = wx.Button(self, -1, "Browse")
        self.txtCtrlSoundResource = wx.TextCtrl(self, -1, "")
        self.btnBrowseResource = wx.Button(self, -1, "Browse")
        self.btnOK = wx.Button(self, wx.ID_OK, "")
        self.btnCancel = wx.Button(self, wx.ID_CANCEL, "")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.buttonBrowseText, self.btnBrowseText)
        self.Bind(wx.EVT_BUTTON, self.buttonBrowseResource, self.btnBrowseResource)

    def __set_properties(self):
        self.SetTitle("Export to Game Resources")
        self.lblHelpText.SetMinSize((329, 78))

    def __do_layout(self):
        szrMain = wx.BoxSizer(wx.VERTICAL)
        szrBottom = wx.BoxSizer(wx.HORIZONTAL)
        szrResource = wx.StaticBoxSizer(self.szrResource_staticbox, wx.HORIZONTAL)
        szrText = wx.StaticBoxSizer(self.szrText_staticbox, wx.HORIZONTAL)
        szrHelpText = wx.StaticBoxSizer(self.szrHelpText_staticbox, wx.HORIZONTAL)
        szrHelpText.Add(self.lblHelpText, 1, 0, 0)
        szrMain.Add(szrHelpText, 2, wx.ALL|wx.EXPAND, 10)
        szrText.Add(self.txtCtrlTextFile, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        szrText.Add(self.btnBrowseText, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 0)
        szrMain.Add(szrText, 1, wx.ALL|wx.EXPAND, 5)
        szrResource.Add(self.txtCtrlSoundResource, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        szrResource.Add(self.btnBrowseResource, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 0)
        szrMain.Add(szrResource, 1, wx.ALL|wx.EXPAND, 5)
        szrBottom.Add(self.btnOK, 0, wx.ALIGN_BOTTOM, 0)
        szrBottom.Add(self.btnCancel, 0, wx.ALIGN_BOTTOM, 0)
        szrMain.Add(szrBottom, 0, wx.ALL|wx.ALIGN_RIGHT, 10)
        self.SetSizer(szrMain)
        szrMain.Fit(self)
        self.Layout()

    def buttonBrowseText(self, event):
        od = wx.FileDialog(self,
                           "Save dialogue text file",
                           wildcard="TXT files (*.txt)|*.txt|All Files|*.*",
                           style=wx.SAVE|wx.CHANGE_DIR)
        if od.ShowModal() == wx.ID_OK:
            filename = od.GetPath()
            self.txtCtrlTextFile.SetValue(filename)

    def buttonBrowseResource(self, event):
        od = wx.FileDialog(self,
                           "Save sound resource file",
                           wildcard=ssglob.gSpeechMap.compression_type + " " +
                           ssglob.gSpeechMap.resource_type + " files|*" + ssglob.gSpeechMap.get_resource_file_ext() + "|" +
                           "All Files|*.*",
                           style=wx.SAVE|wx.CHANGE_DIR)
        if od.ShowModal() == wx.ID_OK:
            filename = od.GetPath()
            self.txtCtrlSoundResource.SetValue(filename)

    def getTextPath(self):
        return self.txtCtrlTextFile.GetValue()

    def getResourcePath(self):
        return self.txtCtrlSoundResource.GetValue()



