import wx
from ui.ids import *

class FindTextDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # This is ripped from DRO Trimmer
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)

        self.parent = args[0]

        self.lTTF = wx.StaticText(self, -1, "Text to find:")
        self.tcSearchText = wx.TextCtrl(self, -1, "")
        self.cbSearchDesc = wx.CheckBox(self, -1, "Search descriptions")
        self.bOk = wx.Button(self, ID_BUTTON_FINDNEXT, "Find Next")
        self.bCancel = wx.Button(self, wx.ID_CANCEL, "Close")

        wx.EVT_BUTTON(self, ID_BUTTON_FINDNEXT, self.parent.parent.buttonFindText)

        self.__set_properties()
        self.__do_layout()

    def __set_properties(self):
        self.SetTitle("Find Text")

    def __do_layout(self):
        sMain = wx.BoxSizer(wx.VERTICAL)
        sBottom = wx.BoxSizer(wx.HORIZONTAL)

        gsTop = wx.FlexGridSizer(1, 2, 0, 0)
        gsTop.Add(self.lTTF, 0, 0, 0)
        gsTop.Add(self.tcSearchText, 0, 0, 0)
        gsTop.Add(self.cbSearchDesc, 0, wx.ALIGN_RIGHT, 0)
        sMain.Add(gsTop, 1, wx.EXPAND, 0)

        sBottom.Add(self.bOk, 0, 0, 0)
        sBottom.Add(self.bCancel, 0, wx.LEFT, 10)
        sMain.Add(sBottom, 0, wx.ALL|wx.ALIGN_RIGHT, 5)

        self.SetSizer(sMain)
        sMain.Fit(self)
        self.Layout()

    def getSearchText(self):
        return self.tcSearchText.GetValue()

    def shouldSearchDesc(self):
        return self.cbSearchDesc.IsChecked()
